Controllers/IngredientController.cs
using System;
using System.Collections.Generic;
using System.Data;
using System.Data.Entity;
using System.Data.Entity.Infrastructure;
using System.Linq;
using System.Net;
using System.Threading.Tasks;
using System.Web;
using System.Web.Mvc;
using CoolerApplication.Models;

namespace CoolerApplication.Controllers
{
    public class IngredientController : Controller
    {
        readonly ApplicationDbContext db = new ApplicationDbContext();

        
        /// <summary>
        /// method for the index page
        /// </summary>
        /// <param name="Search">get the search information and pass it trough the method</param>
        /// <returns>returns view page</returns>
        public ActionResult Index(string Search)
        {
            List<Ingredient> ingredients;
            if (!String.IsNullOrEmpty(Search))
            {
                ingredients = db.Ingredients.Where(i => i.Name.Contains(Search)).ToList();
            }
            else
            {
                ingredients = db.Ingredients.ToList();
            }
            return View(ingredients);
        }

        /// <summary>
        /// method for the details page
        /// </summary>
        /// <param name="id">get the id of the selected ingredient and pass it trough the method</param>
        /// <returns>view page</returns>
        public ActionResult Details(int? id)
        {
            if (id == null)
            {
                return new HttpStatusCodeResult(HttpStatusCode.BadRequest);
            }
            Ingredient ingredient = db.Ingredients.Find(id);
            if (ingredient == null)
            {
                return HttpNotFound();
            }
            return View(ingredient);
        }

      /// <summary>
      /// method for the create view page
      /// </summary>
      /// <returns>view page</returns>
        public ActionResult Create()
        {
            return View();
        }

        /// <summary>
        /// method to store the ingredient
        /// </summary>
        /// <param name="ingredient">pass the model trough the method</param>
        /// <returns>returns to action index</returns>
        [HttpPost]
        public ActionResult Create(Ingredient ingredient)
        {
            try
            {
                if (ModelState.IsValid)
                {
                    db.Ingredients.Add(ingredient);
                    db.SaveChanges();
                    return RedirectToAction("Index");
                }
            }
            catch (RetryLimitExceededException /* dex */)
            {
                //Log the error (uncomment dex variable name and add a line here to write a log.)
                ModelState.AddModelError("", "Unable to save changes. Try again, and if the problem persists, see your system administrator.");
            }

            return RedirectToAction("Index");
        }

     /// <summary>
     /// Edit method that returns the edit view
     /// </summary>
     /// <param name="id">id of the ingredient</param>
     /// <returns>returns view with the ingredient</returns>
        public ActionResult Edit(int? id)
        {
            if (id == null)
            {
                return new HttpStatusCodeResult(HttpStatusCode.BadRequest);
            }
            Ingredient ingredient = db.Ingredients.Find(id);
            if (ingredient == null)
            {
                return HttpNotFound();
            }
            return View(ingredient);
        }

       /// <summary>
       /// method that proccesses the edited data
       /// </summary>
       /// <param name="id">id of the ingredient</param>
       /// <returns>ingredient update page</returns>
        [HttpPost]
        public ActionResult Edit(int id)
        {

            var ingredientToUpdate = db.Ingredients.Find(id);
            if (TryUpdateModel(ingredientToUpdate, "",
                new string[] { "Name", "Amount" }))
                try
                {
                    db.SaveChanges();
                    return RedirectToAction("Index");
                }
                catch (RetryLimitExceededException /* dex */)
                {
                    //Log the error (uncomment dex variable name and add a line here to write a log.
                    ModelState.AddModelError("",
                        "Unable to save changes. Try again, and if the problem persists, see your system administrator.");
                }

            return View(ingredientToUpdate);
        }

      /// <summary>
      /// method that redirect to delete page
      /// </summary>
      /// <param name="id">id of the ingredient</param>
      /// <param name="saveChangesError">check if you really want to delete</param>
      /// <returns>ingredient delete page</returns>
        public ActionResult Delete(int? id, bool? saveChangesError = false)
        {
            if (id == null)
            {
                return new HttpStatusCodeResult(HttpStatusCode.BadRequest);
            }
            if (saveChangesError.GetValueOrDefault())
            {
                ViewBag.ErrorMessage = "Delete failed. Try again, and if the problem persists see your system administrator.";
            }
            Ingredient ingredient = db.Ingredients.Find(id);
            if (ingredient == null)
            {
                return HttpNotFound();
            }

            return View(ingredient);
        }

        /// <summary>
        /// Delete function to delete 
        /// </summary>
        /// <param name="id">id of the card</param>
        /// <param name="collection"></param>
        /// <returns>index page of ingredients</returns>
        
        [HttpPost]
        public ActionResult Delete(int? id)
        {
            if(id ==null){
                return new HttpStatusCodeResult(HttpStatusCode.BadRequest);
            }
            try
            {
                Ingredient ingredient = db.Ingredients.Find(id);
                db.Ingredients.Remove(ingredient);
                db.SaveChanges();
            }
            catch (DataException /* dex */)
            {
                //Log the error (uncomment dex variable name and add a line here to write a log.
                return RedirectToAction("Delete", new {id, saveChangesError = true});
            }
            return RedirectToAction("Index");
        }
    }
}

Views/Ingredient/Create.cshtml
@model CoolerApplication.Models.Ingredient

@{
    ViewBag.Title = "Create";
    Layout = "~/Views/Shared/_Layout.cshtml";
}
@Html.Partial(
    "../Auth/_Auth"
    )
<div class="container-sm mt-3">

    <h2>Create Ingredient</h2>


    @using (Html.BeginForm())
    {
        @Html.AntiForgeryToken()

        <div class="form-horizontal">

            <hr />
            @Html.ValidationSummary(true, "", new { @class = "text-danger" })



            <div class="form-group">

                @Html.LabelFor(model => model.Name, htmlAttributes: new { @class = "control-label col-md-2" })

                <div class="col-md-10">

                    @Html.EditorFor(model => model.Name, new { htmlAttributes = new { @class = "form-control" } })
                    @Html.ValidationMessageFor(model => model.Name, "", new { @class = "text-danger" })

                </div>
            </div>

            <div class="form-group">

                @Html.LabelFor(model => model.Amount, htmlAttributes: new { @class = "control-label col-md-2" })

                <div class="col-md-10">

                    @Html.EditorFor(model => model.Amount, new { htmlAttributes = new { min = 0, @class = "form-control" } })
                    @Html.ValidationMessageFor(model => model.Amount, "", new { @class = "text-danger" })

                </div>
            </div>

            <div class="form-group">
                <div class="col-md-offset-2 col-md-10">

                    <input type="submit" value="Create" class="btn btn-default" />

                </div>
            </div>
        </div>
    }

    <div>
        @Html.ActionLink("Back to List", "Index")
    </div>
</div>
@section Scripts {
    @Scripts.Render("~/bundles/jqueryval")
}

Views/Ingredient/Delete.cshtml
@model CoolerApplication.Models.Ingredient

@{
    ViewBag.Title = "Delete";
    Layout = "~/Views/Shared/_Layout.cshtml";
}
@Html.Partial(
    "../Auth/_Auth"
    )
<div class="container-sm mt-3">

    <h2>Delete ingredient</h2>

    <h3>Are you sure you want to delete this?</h3>
    <div>
        <hr />
        <dl class="dl-horizontal">
            <dt>
                @Html.DisplayNameFor(model => model.Name)
            </dt>

            <dd>
                @Html.DisplayFor(model => model.Name)
            </dd>

            <dt>
                @Html.DisplayNameFor(model => model.Amount)
            </dt>

            <dd>
                @Html.DisplayFor(model => model.Amount)
            </dd>

        </dl>

        @using (Html.BeginForm())
        {
            @Html.AntiForgeryToken()

            <div class="form-actions no-color">
                <input type="submit" value="Delete" class="btn btn-danger" /> |
                @Html.ActionLink("Back to List", "Index")
            </div>
        }
    </div>
</div>

Views/Ingredient/Details.cshtml
@model CoolerApplication.Models.Ingredient

@{
    ViewBag.Title = "Details";
}
@Html.Partial(
    "../Auth/_Auth"
    )
<div class="container-sm mt-3">

    <h2>Ingredient details</h2>

    <div>
        <hr />
        <dl class="dl-horizontal">
            <dt>
                @Html.DisplayNameFor(model => model.Name)
            </dt>

            <dd>
                @Html.DisplayFor(model => model.Name)
            </dd>

            <dt>
                @Html.DisplayNameFor(model => model.Amount)
            </dt>

            <dd>
                @Html.DisplayFor(model => model.Amount)
            </dd>

        </dl>
    </div>
    <p>
        @Html.ActionLink("Edit", "Edit", new { id = Model.Id }) |
        @Html.ActionLink("Back to List", "Index")
    </p>
</div>

Views/Ingredient/Edit.cshtml
@model CoolerApplication.Models.Ingredient

@{
    ViewBag.Title = "Edit";
    Layout = "~/Views/Shared/_Layout.cshtml";
}
@Html.Partial(
    "../Auth/_Auth"
    )
<div class="container-sm mt-3">

    <h2>Edit ingredient</h2>


    @using (Html.BeginForm())
    {
        @Html.AntiForgeryToken()

        <div class="form-horizontal">

            <div class="form-group">
                @Html.LabelFor(model => model.Name, htmlAttributes: new { @class = "control-label col-md-2" })
                <div class="col-md-10">
                    @Html.EditorFor(model => model.Name, new { htmlAttributes = new { @class = "form-control" } })
                    @Html.ValidationMessageFor(model => model.Name, "", new { @class = "text-danger" })
                </div>
            </div>

            <div class="form-group">
                @Html.LabelFor(model => model.Amount, htmlAttributes: new { @class = "control-label col-md-2" })
                <div class="col-md-10">

                    @Html.EditorFor(model => model.Amount, new { htmlAttributes = new { min = 0, @class = "form-control" } })

                    @Html.ValidationMessageFor(model => model.Amount, "", new { @class = "text-danger" })
                </div>
            </div>

            <div class="form-group">
                <div class="col-md-offset-2 col-md-10">

                    <input type="submit" value="Save" class="btn btn-primary" />
                </div>
            </div>
        </div>
    }

    <div>
        @Html.ActionLink("Back to List", "Index")
    </div>

    @section Scripts {
        @Scripts.Render("~/bundles/jqueryval")
    }
</div>

Views/Ingredient/Index.cshtml
@using System.Drawing
@model IEnumerable<CoolerApplication.Models.Ingredient>

@{
    ViewBag.Title = "Index";
    Layout = "~/Views/Shared/_Layout.cshtml";
}
@Html.Partial(
    "../Auth/_Auth"
    )
<div class="container-sm mt-3">

    <h2 class="mb-3">Ingredients</h2>

    <p>
        @Html.ActionLink("Create New", "Create", "Ingredient", null, new { @class = "btn btn-success btn-large" })
    </p>
    <form asp-controller="Ingredient" asp-action="Index">
        <p>
            <div class="form-group">
                Name:<input class="form-control" type="text" name="Search">
            </div>
            <button class="btn btn-info" type="submit">Search</button>
        </p>
    </form>
    <table class="table">
        <tr>
            <th>
                @Html.DisplayNameFor(model => model.Name)
            </th>
            <th>
                @Html.DisplayNameFor(model => model.Amount)
            </th>
            <th></th>
        </tr>

        @foreach (var item in Model)
        {
            <tr>
                <td>
                    @Html.DisplayFor(modelItem => item.Name)
                </td>
                <td>
                    @Html.DisplayFor(modelItem => item.Amount)
                </td>
                <td>
                    @Html.ActionLink("Edit", "Edit", new { id = item.Id }) |
                    @Html.ActionLink("Details", "Details", new { id = item.Id }) |
                    @Html.ActionLink("Delete", "Delete", new { id = item.Id })
                </td>
            </tr>
        }
    </table>
</div>